VERSION 5.00
Begin VB.UserControl Waiter 
   CanGetFocus     =   0   'False
   ClientHeight    =   690
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   690
   HasDC           =   0   'False
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Waiter.ctx":0000
   ScaleHeight     =   46
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   46
   ToolboxBitmap   =   "Waiter.ctx":030A
End
Attribute VB_Name = "Waiter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ,   HANDLE,    SYNCHRONIZE,
'    .

',       .
'  ,     HANDLE  , 
'  .  ,   TerminateWait.

'    WM_LBUTTONUP, ,  
'   ,   ( ) , 
'   Waiter,   ,     
'. ,      ,   
',   .     ,  , 
'   KeyPreview.     
',       .
'    ,     
'    ,  , , WM_PAINT - 
'    ,      ...
'     :)


'(c) GSerg, 2005



'  26  2006 .
'
'  Waiter'     DEP, ,   
'Windows,    ,   ,    
' ,   .   MSDN ,  
'GlobalAlloc      ,   ,  
'        .
',  Waiter'      DEP ,
'      .    MSDN   
'   :   GlobalAlloc  , 
'     ,     
'        VirtualProtect.

', Waiter       , ,
'  .
'  VirtualAlloc    , 
'    ,      ( ,
',  4 ),   ,  . ,  
'Waiter'          
'(, ,    PE- ),     
'4    .
'   GlobalAlloc   VirtualProtect,  
'   , .. GlobalAlloc  
'   ,        
',   ,        , 
'  VirtualProtect       , 
'    GlobalAlloc  ,  
' Waiter. ,      , 
'     ,  ,  
'copy-on-write  ,   GlobalAlloc, .

'!       .
'     ,  VirtualAlloc.
' ,   GlobalAlloc.  :

#Const USE_VIRTUAL_ALLOC = True


Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Private Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long
Private Declare Function PutMem4 Lib "msvbvm60" (ByVal pDWORDDst As Long, ByVal NewValue As Long) As Long
Private Declare Function PutMem1 Lib "msvbvm60" (ByVal pDWORDDst As Long, ByVal NewValue As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Private Declare Function WaitForMultipleObjects Lib "kernel32" (ByVal nCount As Long, ByRef lpHandles As Long, ByVal bWaitAll As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, ByRef lpExitCode As Long) As Long

#If USE_VIRTUAL_ALLOC Then
  Private Declare Function VirtualAlloc Lib "kernel32.dll" (ByRef lpAddress As Any, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
  Private Declare Function VirtualFree Lib "kernel32.dll" (ByRef lpAddress As Any, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
#Else
  Private Declare Function GlobalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
  Private Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
  Private Declare Function VirtualProtect Lib "kernel32.dll" (ByRef lpAddress As Any, ByVal dwSize As Long, ByVal flNewProtect As Long, ByRef lpflOldProtect As Long) As Long
#End If

#If USE_VIRTUAL_ALLOC Then
  Private Const MEM_COMMIT As Long = &H1000
  Private Const MEM_RELEASE As Long = &H8000
#Else
  Private Const GMEM_FIXED As Long = &H0
  Private Const GMEM_ZEROINIT As Long = &H40
#End If

Private Const PAGE_EXECUTE_READWRITE As Long = &H40

Private Const WM_PAINT As Long = &HF
Private Const INFINITE As Long = &HFFFFFFFF

Private Const STATUS_ABANDONED_WAIT_0 As Long = &H80
Private Const STATUS_WAIT_0 As Long = &H0
Private Const WAIT_ABANDONED_0 As Long = STATUS_ABANDONED_WAIT_0 + 0
Private Const WAIT_OBJECT_0 As Long = STATUS_WAIT_0 + 0
Private Const WAIT_FAILED As Long = &HFFFFFFFF
Private Const WAIT_TIMEOUT As Long = 258&

Private Const MAXIMUM_WAIT_OBJECTS As Long = 64


Private kernel As Long, user As Long, hMemCommon As Long
Private mHandle As Long, tID As Long
Private LowerBound As Long
Private mWaitHandles() As Long, mCanEraseWaitHandles As Boolean

Public Enum wtrResult
  wtrAbandoned = WAIT_ABANDONED_0
  wtrSucceeded = WAIT_OBJECT_0
  wtrTimeOut = WAIT_TIMEOUT
  wtrFailed = WAIT_FAILED
End Enum

Public Event Complete(ByVal Result As wtrResult, ByVal Index As Long)

Public Sub Wait(ByVal Handle As Long, Optional ByVal TimeOut As Long = INFINITE)
  TerminateWait
  
  PutMem4 hMemCommon + 1, TimeOut
  
  ReDim mWaitHandles(0 To 0)
  mWaitHandles(0) = Handle
  LowerBound = 0
  mCanEraseWaitHandles = False
  
  mHandle = CreateThread(ByVal 0&, &H10000, hMemCommon, ByVal Handle, 0, tID)
End Sub

Public Sub WaitForMany(Handles() As Long, ByVal WaitForAll As Boolean, Optional ByVal TimeOut As Long = INFINITE)
  If UBound(Handles) - LBound(Handles) + 1 > MAXIMUM_WAIT_OBJECTS Then Err.Raise 5, Extender.Name, "Too many handles"
  
  TerminateWait
  
  PutMem4 hMemCommon + 48 + 1, TimeOut
  
  If WaitForAll Then
    PutMem4 hMemCommon + 48 + 6, 1
  Else
    PutMem4 hMemCommon + 48 + 6, 0
  End If
  
  PutMem4 hMemCommon + 48 + 15, UBound(Handles) - LBound(Handles) + 1
  
  mWaitHandles = Handles
  LowerBound = LBound(mWaitHandles)
  mCanEraseWaitHandles = False
  
  mHandle = CreateThread(ByVal 0&, &H10000, hMemCommon + 48, mWaitHandles(LowerBound), 0, tID)
End Sub

Public Function Test(ByVal Handle As Long) As wtrResult
  Test = WaitForSingleObject(Handle, 0)
End Function

Public Function TestMany(Handles() As Long, ByRef Index As Long, Optional ByVal AllMustBeSignalled As Boolean = False) As wtrResult
  If UBound(Handles) - LBound(Handles) + 1 > MAXIMUM_WAIT_OBJECTS Then Err.Raise 5, Extender.Name, "Too many handles"
  
  TestMany = WaitForMultipleObjects(UBound(Handles) - LBound(Handles) + 1, Handles(LBound(Handles)), IIf(AllMustBeSignalled, 1&, 0&), 0)
  
  Select Case TestMany
  Case WAIT_OBJECT_0 To WAIT_OBJECT_0 + MAXIMUM_WAIT_OBJECTS - 1
    Index = TestMany - WAIT_OBJECT_0 + LBound(Handles): TestMany = wtrSucceeded
  Case WAIT_ABANDONED_0 To WAIT_ABANDONED_0 + MAXIMUM_WAIT_OBJECTS - 1
    Index = TestMany - WAIT_ABANDONED_0 + LBound(Handles): TestMany = wtrAbandoned
  End Select
End Function


Public Function GetHandles() As Long()
  GetHandles = mWaitHandles
End Function

Public Property Get Handle(Optional Index As Variant) As Long
  If IsMissing(Index) Then
    Handle = mWaitHandles(LowerBound)
  Else
    Handle = mWaitHandles(Index)
  End If
End Property


Public Sub TerminateWait()
  If mHandle Then
    TerminateThread mHandle, 0
    CloseHandle mHandle
    mHandle = 0
    Erase mWaitHandles
  End If
End Sub

Private Sub UserControl_Initialize()
  
  '44 -  
  '54 -  
  ' 4 - ,       8 
  
#If USE_VIRTUAL_ALLOC Then
  hMemCommon = VirtualAlloc(ByVal 0&, 44 + 4 + 54, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
  If hMemCommon = 0 Then Err.Raise 7, Extender.Name
#Else
  Dim op As Long
  
  hMemCommon = GlobalAlloc(GMEM_FIXED Or GMEM_ZEROINIT, 44 + 4 + 54)
  If hMemCommon = 0 Then Err.Raise 7, Extender.Name
  
  If VirtualProtect(ByVal hMemCommon, 44 + 4 + 54, PAGE_EXECUTE_READWRITE, op) = 0 Then
    GlobalFree hMemCommon
    Err.Raise 5, Extender.Name, "Cannot change memory protection."
  End If
#End If
  
  
  kernel = LoadLibrary("kernel32")
  user = LoadLibrary("user32")
  
  
  ' :     Wait
  
  PutMem1 hMemCommon, &H68           'push imm32 (TimeOut value goes next (set from WAIT procedure))
  
  PutMem4 hMemCommon + 5, &H82474FF  'push [esp+0x08]   (lParam of thread)
  PutMem1 hMemCommon + 9, &HE8
  PutMem4 hMemCommon + 10, GetProcAddress(kernel, "WaitForSingleObject") - hMemCommon - 10 - 4
  
  PutMem1 hMemCommon + 14, &H50      'push eax   (WaitForSingleObject result)
  PutMem1 hMemCommon + 15, &H68      'push imm32 (lParam - leave it zero)
  PutMem1 hMemCommon + 20, &H68      'push imm32 (wParam - leave it zero)
  PutMem1 hMemCommon + 25, &H68      'push imm32 (uMsg)
  PutMem4 hMemCommon + 26, WM_PAINT
  PutMem1 hMemCommon + 30, &H68      'push imm32 (hWnd)
  PutMem4 hMemCommon + 31, UserControl.hWnd
  PutMem1 hMemCommon + 35, &HE8
  PutMem4 hMemCommon + 36, GetProcAddress(user, "PostMessageA") - hMemCommon - 36 - 4
  PutMem1 hMemCommon + 40, &H58      'pop eax
  PutMem4 hMemCommon + 41, &H4C2&
  
  
  
  ' :     WaitMany
  
  PutMem1 hMemCommon + 48, &H68          'push imm32 (TimeOut value goes next (set from WAITMANY procedure))
  
  PutMem1 hMemCommon + 48 + 5, &H68      'push imm32 (WaitForAll value goes next (set from WAITMANY procedure))
  
  PutMem4 hMemCommon + 48 + 10, &HC2474FF 'push [esp+0x0C]   (lParam of thread)
  PutMem1 hMemCommon + 48 + 14, &H68     'push imm32 (number of handles goes next (set from WAITMANY procedure))
  
  PutMem1 hMemCommon + 48 + 19, &HE8
  PutMem4 hMemCommon + 48 + 20, GetProcAddress(kernel, "WaitForMultipleObjects") - hMemCommon - 48 - 20 - 4
  
  PutMem1 hMemCommon + 48 + 24, &H50     'push eax   (WaitForMultipleObjects result)
  PutMem1 hMemCommon + 48 + 25, &H68     'push imm32 (lParam - leave it zero)
  PutMem1 hMemCommon + 48 + 30, &H68     'push imm32 (wParam - leave it zero)
  PutMem1 hMemCommon + 48 + 35, &H68     'push imm32 (uMsg)
  PutMem4 hMemCommon + 48 + 36, WM_PAINT
  PutMem1 hMemCommon + 48 + 40, &H68     'push imm32 (hWnd)
  PutMem4 hMemCommon + 48 + 41, UserControl.hWnd
  PutMem1 hMemCommon + 48 + 45, &HE8
  PutMem4 hMemCommon + 48 + 46, GetProcAddress(user, "PostMessageA") - hMemCommon - 48 - 46 - 4
  PutMem1 hMemCommon + 48 + 50, &H58     'pop eax
  PutMem4 hMemCommon + 48 + 51, &H4C2&
  
End Sub

Private Sub UserControl_Paint()
  Dim r As Long
  
  '          -
  'pop  ret.     ...
  WaitForSingleObject mHandle, INFINITE
  
  GetExitCodeThread mHandle, r
  CloseHandle mHandle
  mHandle = 0
  
  mCanEraseWaitHandles = True
  
  Select Case r
  Case WAIT_OBJECT_0 To WAIT_OBJECT_0 + MAXIMUM_WAIT_OBJECTS - 1
    RaiseEvent Complete(wtrSucceeded, r - WAIT_OBJECT_0 + LowerBound)
  Case WAIT_ABANDONED_0 To WAIT_ABANDONED_0 + MAXIMUM_WAIT_OBJECTS - 1
    RaiseEvent Complete(wtrAbandoned, r - WAIT_ABANDONED_0 + LowerBound)
  Case WAIT_TIMEOUT
    RaiseEvent Complete(wtrTimeOut, 0)
  Case WAIT_FAILED
    RaiseEvent Complete(wtrFailed, 0)
  End Select
  
  If mCanEraseWaitHandles Then Erase mWaitHandles
End Sub

Private Sub UserControl_Terminate()
  TerminateWait
  
#If USE_VIRTUAL_ALLOC Then
  VirtualFree ByVal hMemCommon, 0, MEM_RELEASE
#Else
  GlobalFree hMemCommon
#End If
  
  FreeLibrary kernel
  FreeLibrary user
End Sub

Private Sub UserControl_Resize()
  UserControl.Width = 520
  UserControl.Height = 520
End Sub
